/* ȥ륰եå 3D */

#ifndef KAME3D_H
#define KAME3D_H

typedef struct {
	double x, y, z;	// 
	double deg;	//  (deg)
	int    pen;	// ڥ (up/down)
	int    color;	// ڥ󥫥顼
	double v;	// ԡ
	double power;	// jump power
	int    spin;	// spin num

	double rad;	//  (rad)
	double c, s;	// cos, sin
} tgState;

#define TG_TRACE_MAX	100000

typedef struct {
	tgState buf[TG_TRACE_MAX];	// ­ץХåե
	int     cur;			// ȥݥ

	double	x, y, z;	// ߤΰ
	double deg, rad;	// ߤγ
} tgObj;

#define TG_STEP		0.1

#endif

//////////////////////////////////////////////////
// API

// ץؿ
extern void tgInit(int argc, char **argv, char *title);
extern void tgInitCanvas(int w, int h);
extern void tgInitObj(tgObj *obj, double x, double y, double deg);
extern tgObj *tgNewTurtle(double x, double y, double deg);
extern void tgFreeTurtle(tgObj *obj);
extern void tgPlay(int msec, tgObj *obj[], int n);

// ؿ
extern void tgPenUp(tgObj *obj);
extern void tgPenDown(tgObj *obj);
extern int tgSetColor(tgObj *obj, int color);
extern int tgSetPower(tgObj *obj, double power);
extern int tgSetSpin(tgObj *obj, int spin);
extern void tgGoto(tgObj *obj, double x, double y);
extern void tgHead(tgObj *obj, double deg);
extern void tgMove(tgObj *obj, double step);
extern void tgTurn(tgObj *obj, double deg);

// ִؿ
extern double tgPosX(tgObj *obj);
extern double tgPosY(tgObj *obj);
extern double tgDir(tgObj *obj);
extern int tgPen(tgObj *obj);
extern int tgColor(tgObj *obj);
extern int tgStep();

//////////////////////////////////////////////////
// ʰAPI 

extern tgObj *tg_kame;
extern void Init(char *title);
extern void InitTurtle(double x, double y, double deg);
#define InitCanvas(w, h)	tgInitCanvas(w, h)
#define Play()		tgPlay(10, &tg_kame, 1)
#define PenUp()		tgPenUp(tg_kame)
#define PenDown()	tgPenDown(tg_kame)
#define SetColor(color)	tgSetColor(tg_kame, color)
#define SetPower(power)	tgSetPower(tg_kame, power)
#define SetSpin(num)	tgSetSpin(tg_kame, num)
#define Goto(x, y)	tgGoto(tg_kame, x, y)
#define Head(deg)	tgHead(tg_kame, deg)
#define Move(step)	tgMove(tg_kame, step)
#define Turn(deg)	tgTurn(tg_kame, deg)
#define PosX()		tgPosX(tg_kame)
#define PosY()		tgPosY(tg_kame)
#define Dir()		tgDir(tg_kame)
#define Pen()		tgPen(tg_kame)
#define Color()		tgColor(tg_kame)
#define Step()		tgStep(tg_kame)
extern int Rand(int n);

